#include "PacmanRed.h"
//#include "Pacman.h"

#include "core/CoreIncludes.h"
#include "BulletDynamics/Dynamics/btRigidBody.h"



	namespace orxonox{

		RegisterClass(PacmanRed);

		PacmanRed::PacmanRed(Context* context) : PacmanGhost(context){

        RegisterObject(PacmanRed);
        this->target_x=0;
        this->target_z=15;
        this->lastPlayerPassedPoint=Vector3(70,10,-135);
          
    }


    /**
    @brief
        Method for creating a ghost through XML.
    */
    void PacmanRed::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(PacmanRed, XMLPort, xmlelement, mode);
    }

    /*void PacmanRed::setPlayerPos(Vector3 _playerPos)
    {
        this->playerPos = _playerPos;
    }*/

    bool PacmanRed::jeanfindpos(Vector3 one, Vector3 other){
       if((abs(one.x - other.x)<15) && (abs(one.y - other.y)<15) && (abs(one.z - other.z)<15)) return true;
        return false;
        }

    void PacmanRed::tick(float dt)
    {
        SUPER(PacmanGhost, tick, dt);

        this->actuelposition = this->getPosition();

        for(int u=0; u < 67; u++){//always check if player passed a point
            if(jeanfindpos(this->getPlayerPos(), possibleposition[u])){
            this->lastPlayerPassedPoint=possibleposition[u];
                    }
            }

        
        //Stop, if target arrived
        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
                 this->ismoving = false;
        }

        //Move, if ghost hasn't arrived yet
        if(this->ismoving){
            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
                move(dt, actuelposition, velocity);
            }    
            if(!(abs(this->actuelposition.x-target_x)<0.5)){
                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
                move(dt, actuelposition, velocity);
            }
        }
        
        //Check on which position the ghost has arrived and set new target
        else{

            while(lockmove){};
            lockmove = true;

        	//do red behavior
            //Use target_x and target_z for position of red pacman

            Vector3 redPos=Vector3(this->target_x, 10, this->target_z);
            //nextMove(this->getPlayerPos(), redPos);


            if(this->actuelposition!=lastPlayerPassedPoint){
                //std::cout<<this->target_x<<" "<<this->target_z<<endl;
                std::cout<<redPos<<endl;
                std::cout<<this->lastPlayerPassedPoint<<endl;
                //getShortestPath(Vector3(-215,10,-195),Vector3(70,10,-135));
                //getShortestPath(redPos, lastPlayerPassedPoint);
            nextMove(redPos, lastPlayerPassedPoint);
            }/*
            else{// red pacman is at lastPlayerPassedPoint
            nextMove(this->getPlayerPos(), redPos);
            }*/

            //setNewTargetRed(Vector3(70,10,-85));
            //std::cout<<this->target_x<<" "<<target_z<<endl;
            //std::cout<<"meuh"<<endl;
            //std::cout<<this->actuelposition;

            lockmove=false; //NEVER FORGET THIS ONE !!!!!!!
        }
        
    }


	void PacmanRed::setNewTargetRed(Vector3 goalToGo){

					this->target_x = goalToGo.x;
                    this->target_z = goalToGo.z; 
                    this->ismoving = true;
	}


	void PacmanRed::nextMove( Vector3 redPosP, Vector3 playerPos){
	
        Vector3 nextTarget;

	   nextTarget = getShortestPath(redPosP, playerPos);
	
	   setNewTargetRed(nextTarget);
	}



    //save last checkpoint crossed by player 
    /* 
        void PacmanGelb::tick(float dt){ //last passed point of player
            for(int u=0; u < 67; u++){
            if(findpos(this->getPosition(), possibleposition[u])){
            this->lastPassedPoint=possibleposition[u];
                    }
                }
        }
    */

}